<template>
  <div class="zdbh">
    <div class="title">三小时监测站点数据变化趋势</div>
    <div class="handleZoom" @click="handleBig">
      <img src="~@/assets/img/xgzs/展开菜单.png" alt="" />
    </div>
    <div ref="chartRef" class="small-chart"></div>
    <div v-show="showBig" ref="bigRef" class="big-chart" id="bigChart">
      <!-- <div></div> -->
    </div>
  </div>
</template>

<script>
import * as echarts from "echarts";
import { ref, onMounted, reactive, nextTick } from "vue";

import {qxshControllerByTime, locationControllerQ, getLocationDataChange} from "@/api/api.js";
import dayjs from "dayjs";
export default {
  setup() {
    const config = reactive({
      header: ["名称", "数值", "日期"],
      data: [
        ["监测站1", "2.5", "2022001"],
        ["监测站1", "2.5", "2022001"],
        ["监测站1", "2.5", "2022001"],
        ["监测站1", "2.5", "2022001"],
        ["监测站1", "2.5", "2022001"],
        ["监测站1", "2.5", "2022001"],
        ["监测站1", "2.5", "2022001"],
        ["监测站1", "2.5", "2022001"],
        ["监测站1", "2.5", "2022001"],
        ["监测站1", "2.5", "2022001"],
      ],
      // index: true,
      columnWidth: [],
      align: ["center", "center", "center"],
      headerBGC: "transparent",
      oddRowBGC: "transparent",
      evenRowBGC: "transparent",
      rowNum: 10,
    });

    const data = reactive({
      chartX: [
        "13:00",
        "13:05",
        "13:10",
        "13:15",
        "13:20",
        "13:25",
        "13:30",
        "13:35",
        "13:40",
        "13:45",
        "13:50",
        "13:55",
      ],
      chartOne: [20, 10, 12, 14, 12, 16, 12, 20, 12, 19, 13, 15],
      chartTwo: [20, 10, 12, 14, 12, 16, 12, 20, 12, 19, 13, 15],
      chartThree: [20, 10, 12, 14, 12, 16, 12, 20, 12, 19, 13, 15],
    });

    const barData = reactive({
      chartX: ["AI-01", "AI-02", "AI-03", "AI-04"],
      chartOne: [0, 0, 0, 0],
      chartTwo: [0, 0, 0, 0],
      chartThree: [0, 0, 0, 0],
    });
    // 换算方法
    function nowSize(val, initWidth = 1920) {
      let nowClientWidth = document.documentElement.clientWidth;

      return val * (nowClientWidth / initWidth);
    }
    const chartRef = ref(null);
    const bigRef = ref(null);
    const showBig = ref(false);
    function handleBig() {
      showBig.value = !showBig.value;
      // if (showBig.value) {
      //   initBarBig(bigRef.value);
      // }
    }
    onMounted(() => {
      // getSYFKname();
      getList();

      nextTick(() => {
        initBarBig();
        initBar(chartRef.value);
      });
    });
    const getSYFKname = async () => {
      const dt = await locationControllerQ({ type: "监控点" });
      const dt1 = await locationControllerQ({ type: "超级站" });
      let arr = [...dt.result, ...dt1.result];
      const arrX = [];

      arr.forEach((e) => {
        arrX.push(e.name);
      });
      barData.chartX = arrX;
      // console.log("chartX", barData.chartX);
    };
    async function getList() {
      const res = await getLocationDataChange();
      if (res.code == 200) {
        let keys = Object.keys(res.result)
        let arr1 = []
        let arr2 = []
        let arr3 = []
        keys.forEach(item => {
          let obj = res.result[item]
          if (obj.length >= 3){
            arr1.push(obj[obj.length-1])
            arr2.push(obj[obj.length-2])
            arr3.push(obj[obj.length-3])
          }
          else if (obj.length == 2){
            arr1.push(obj[1])
            arr2.push(obj[0])
            arr3.push(0)
          }
          else if (obj.length == 1){
            arr1.push(obj[0])
            arr2.push(0)
            arr3.push(0)
          }
        })
        barData.chartX = keys;
        barData.chartOne = arr1;
        barData.chartTwo = arr2;
        barData.chartThree = arr3;
      }

      initBar(chartRef.value);
      initBarBig();
    }
    // async function getList() {
    //   const res1 = await qxshControllerByTime({
    //     leftTime: dayjs().subtract(1, "hour").format("YYYYMMDDHH"),
    //     rightTime: dayjs().format("YYYYMMDDHH"),
    //   });
    //   const res2 = await qxshControllerByTime({
    //     leftTime: dayjs().subtract(2, "hour").format("YYYYMMDDHH"),
    //     rightTime: dayjs().subtract(1, "hour").format("YYYYMMDDHH"),
    //   });
    //   const res3 = await qxshControllerByTime({
    //     leftTime: dayjs().subtract(3, "hour").format("YYYYMMDDHH"),
    //     rightTime: dayjs().subtract(2, "hour").format("YYYYMMDDHH"),
    //   });
    //
    //   if (
    //     res1.result.length !== 0 ||
    //     res2.result.length !== 0 ||
    //     res3.result.length !== 0
    //   ) {
    //     const arrX = barData.chartX;
    //     const arr1 = Array(arrX.length).fill(0);
    //     const arr2 = Array(arrX.length).fill(0);
    //     const arr3 = Array(arrX.length).fill(0);
    //     res1.result.forEach((v) => {
    //       const index = arrX.findIndex((item) => item == v.name);
    //       if (index) {
    //         arr1[index] = Number(v.value).toFixed(2);
    //       }
    //     });
    //     res2.result.forEach((v) => {
    //       const index = arrX.findIndex((item) => item == v.name);
    //
    //       if (index) {
    //         arr2[index] = Number(v.value).toFixed(2);
    //       }
    //     });
    //     res3.result.forEach((v) => {
    //       const index = arrX.findIndex((item) => item == v.name);
    //
    //       if (index) {
    //         arr3[index] = Number(v.value).toFixed(2);
    //       }
    //     });
    //     barData.chartOne = arr1;
    //     barData.chartTwo = arr2;
    //     barData.chartThree = arr3;
    //
    //     // console.log("chartThree", arr3);
    //     // console.log("chartThree", arr2);
    //     // console.log("chartThree", arr1);
    //   }
    //
    //   initBar(chartRef.value);
    //   initBarBig();
    // }

    function initBar(dom) {
      let myChart = echarts.init(dom);
      const labelOption = {
        show: true,
        position: "insideBottom",
        distance: 15,
        align: "left",
        verticalAlign: "middle",
        rotate: 90,
        formatter: "{c}  {name|{a}}",
        fontSize: 16,
        rich: {
          name: {},
        },
      };
      let option = {
        tooltip: {
          textStyle: {
            fontSize: nowSize(12),
          },
          trigger: "axis",
          axisPointer: {
            type: "shadow",
          },
          lineStyle: {
            color: "#fff",
          },
        },
        legend: {
          show: false,
        },
        grid: {
          top: "5%",
          left: "10%",
          right: "13%",
          bottom: "22%",
          containLabel: true,
        },
        xAxis: [
          {
            boundaryGap: true,
            type: "category",
            textStyle: {
              fontSize: nowSize(14),
              color: "#fff",
            },
            axisLine: {
              lineStyle: {
                color: "#fff",
              },
            },
            axisLabel: {
              padding: [5, 0, 0, nowSize(30)],
              fontSize: nowSize(14),
            },
            data: barData.chartX,
          },
        ],
        yAxis: [
          {
            type: "value",

            axisLine: {
              lineStyle: {
                color: "#fff",
              },
            },
            axisLabel: {
              fontSize: nowSize(12),
            },
          },
        ],
        dataZoom: [
          {
            show: true,
            start: 0,
            end: 6,
            textStyle: {
              color: "#fff", //滚动条两边字体样式
            },
          },
          {
            start: 0,
            end: 6,
          },
        ],
        series: [
          {
            name: "当前",
            // name: "一小时前",
            type: "bar",
            barGap: 0,
            // label: labelOption,
            emphasis: {
              focus: "series",
            },
            data: barData.chartOne,

            itemStyle: {
              normal: {
                color: "rgb(249,40,34)",
              },
            },
          },
          {
            // name: "两小时前",
            name: "一小时前",
            type: "bar",
            // label: labelOption,
            emphasis: {
              focus: "series",
            },
            data: barData.chartTwo,
            itemStyle: {
              normal: {
                color: "rgb(76,249,255)",
              },
            },
          },
          {
            // name: "三小时前",
            name: "两小时前",
            type: "bar",
            // label: labelOption,
            emphasis: {
              focus: "series",
            },
            data: barData.chartThree,
            itemStyle: {
              normal: {
                color: "rgb(255,222,42)",
              },
            },
          },
        ],
      };
      // let option = {
      //   tooltip: {
      //     textStyle: {
      //       fontSize: nowSize(12),
      //     },
      //     trigger: "axis",
      //     axisPointer: {
      //       type: "shadow",
      //     },
      //     lineStyle: {
      //       color: "#fff",
      //     },
      //   },
      //   legend: {
      //     show: false,
      //   },
      //   grid: {
      //     top: "5%",
      //     left: "10%",
      //     right: "13%",
      //     bottom: "16%",
      //     containLabel: true,
      //   },
      //   xAxis: [
      //     {
      //       boundaryGap: true,
      //       type: "category",
      //       textStyle: {
      //         fontSize: nowSize(14),
      //         color: "#fff",
      //       },
      //       axisLine: {
      //         lineStyle: {
      //           color: "#fff",
      //         },
      //       },
      //       axisLabel: {
      //         padding: [5, 0, 0, nowSize(30)],
      //         fontSize: nowSize(14),
      //       },
      //       data: barData.chartX,
      //     },
      //   ],
      //   yAxis: [
      //     {
      //       type: "value",

      //       axisLine: {
      //         lineStyle: {
      //           color: "#fff",
      //         },
      //       },
      //       axisLabel: {
      //         fontSize: nowSize(12),
      //       },
      //     },
      //   ],
      //   series: [
      //     {
      //       name: "一小时前",
      //       type: "bar",
      //       stack: "Ad",
      //       emphasis: {
      //         focus: "series",
      //       },
      //       data: barData.chartOne,
      //     },
      //     {
      //       name: "两小时前",
      //       type: "bar",
      //       stack: "Ad",
      //       emphasis: {
      //         focus: "series",
      //       },
      //       data: barData.chartTwo,
      //     },
      //     {
      //       name: "三小时前",
      //       type: "bar",
      //       stack: "Ad",
      //       emphasis: {
      //         focus: "series",
      //       },
      //       data: barData.chartThree,
      //     },
      //   ],
      // };
      myChart.setOption(option);
      window.onresize = function () {
        //自适应大小
        myChart.resize();
      };
    }
    function initBarBig(dom) {
      let myChart = echarts.init(document.getElementById("bigChart"));
      const labelOption = {
        show: true,
        position: "insideBottom",
        distance: 15,
        align: "left",
        verticalAlign: "middle",
        rotate: 90,
        formatter: "{c}  {name|{a}}",
        fontSize: 16,
        rich: {
          name: {},
        },
      };
      let option = {
        tooltip: {
          textStyle: {
            fontSize: nowSize(12),
          },
          trigger: "axis",
          axisPointer: {
            type: "shadow",
          },
          lineStyle: {
            color: "#fff",
          },
        },
        legend: {
          data: ["一小时前", "两小时前", "三小时前"],
          itemGap: 5,
          textStyle: {
            color: "#ffffff", //字体颜色
          },
          padding: [30, 0, 0, 0], //可设定图例[距上方距离，距右方距离，距下方距离，距左方距离]
        },
        grid: {
          top: "14%",
          left: "10%",
          right: "13%",
          bottom: "15%",
          containLabel: true,
        },
        xAxis: [
          {
            boundaryGap: true,
            type: "category",
            textStyle: {
              fontSize: nowSize(14),
              color: "#fff",
            },
            axisLine: {
              lineStyle: {
                color: "#fff",
              },
            },
            axisLabel: {
              padding: [5, 0, 0, nowSize(30)],
              fontSize: nowSize(14),
            },
            data: barData.chartX,
          },
        ],
        yAxis: [
          {
            type: "value",

            axisLine: {
              lineStyle: {
                color: "#fff",
              },
            },
            axisLabel: {
              fontSize: nowSize(12),
            },
          },
        ],
        dataZoom: [
          {
            show: true,

            textStyle: {
              color: "#fff", //滚动条两边字体样式
            },
          },
        ],
        series: [
          {
            name: "一小时前",
            type: "bar",
            barGap: 0,
            // label: labelOption,
            emphasis: {
              focus: "series",
            },
            data: barData.chartOne,

            itemStyle: {
              normal: {
                color: "rgb(249,40,34)",
              },
            },
          },
          {
            name: "两小时前",
            type: "bar",
            // label: labelOption,
            emphasis: {
              focus: "series",
            },
            data: barData.chartTwo,
            itemStyle: {
              normal: {
                color: "rgb(76,249,255)",
              },
            },
          },
          {
            name: "三小时前",
            type: "bar",
            // label: labelOption,
            emphasis: {
              focus: "series",
            },
            data: barData.chartThree,
            itemStyle: {
              normal: {
                color: "rgb(255,222,42)",
              },
            },
          },
        ],
      };

      myChart.setOption(option);
      window.onresize = function () {
        //自适应大小
        myChart.resize();
      };
    }

    return {
      config,
      chartRef,
      bigRef,
      showBig,
      handleBig,
    };
  },
};
</script>

<style lang="less" scoped>
.zdbh {
  position: absolute;
  top: 497px;
  right: 70px;
  width: 763px;
  height: 560px;
  background: url("~@/assets/img/xgzs/zdbh.png");
  background-size: 100% 100%;
  box-sizing: border-box;
  .title {
    padding: 40px;
    font-size: 30px;
    font-weight: bold;
    color: #ffffff;
    padding-bottom: 10px;
  }
  .handleZoom {
    width: 25px;
    height: 21px;
    position: absolute;
    top: 40px;
    right: 70px;
    cursor: pointer;
    img {
      width: 100%;
      height: 100%;
    }
  }
  .small-chart {
    width: 100%;
    height: 430px;
  }
  .big-chart {
    position: absolute;
    width: 2181px;
    height: 1208px;
    background: url("~@/assets/img/xgzs/zdbg_big.png");
    background-size: 100% 100%;
    top: -2%;
    left: -50%;
    transform: translateX(-84%);
    padding-bottom: 50px;
    box-sizing: border-box;
    // #bigChart {
    //   width: 100%;
    //   height: 95%;
    // }
  }
}
</style>
